use crate::renderer::breadcrumb_tree::BreadcrumbTree;
use crate::renderer::breadcrumb_tree::BreadcrumbTreeNode;
use crate::renderer::context_element::IntoContextElement;
use crate::renderer::WalkError;
use std::borrow::Borrow;

enum WalkResult<'a> {
    NoWalk,
    PartialWalk,
    FullyWalked(&'a dyn IntoContextElement),
}

fn walk_path_from_single_level<'a, P, C>(context: &'a C, path: &[P]) -> WalkResult<'a>
where
    P: Borrow<str>,
    C: Borrow<dyn IntoContextElement + 'a>,
{
    todo!()
}

fn get_first_non_pseudo_element<'a, B>(
    breadcrumbs: &'a BreadcrumbTreeNode<B>,
) -> Option<&'a dyn IntoContextElement>
where
    B: IntoContextElement,
{
    breadcrumbs.iter().filter(|b| b.is_pseudo_element()).next()
}

pub fn walk_path<'a, B, P>(
    maybe_breadcrumbs: Option<&'a BreadcrumbTreeNode<B>>,
    path: &Vec<P>,
) -> Result<&'a dyn IntoContextElement, WalkError>
where
    B: IntoContextElement,
    P: Borrow<str>,
{
    match (maybe_breadcrumbs, path.first()) {
        (None, _) => return Err(WalkError::CantWalk),
        (Some(breadcrumbs), None) => return Ok(breadcrumbs.get_ice()),
        (Some(breadcrumbs), Some(path_first)) if path_first.borrow() == "." => {
            let first_non_pseudo_element = get_first_non_pseudo_element(breadcrumbs);
            // return match first_non_pseudo_element {
            //     None => Err(WalkError::CantWalk),
            //     Some(current_context)
            // }
        }
        (Some(breadcrumbs), Some(path_first)) => (),
    }

    Err(WalkError::CantWalk)
}
